// Code generated by protoc-gen-go-grpc. DO NOT EDIT.

package legiscanner

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
	emptypb "google.golang.org/protobuf/types/known/emptypb"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// LegiscannerClient is the client API for Legiscanner service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type LegiscannerClient interface {
	// Beep makes the legiscanner beep in a happy way
	Beep(ctx context.Context, in *emptypb.Empty, opts ...grpc.CallOption) (*emptypb.Empty, error)
	// Boop makes the legiscanner boop in a sad way
	Boop(ctx context.Context, in *emptypb.Empty, opts ...grpc.CallOption) (*emptypb.Empty, error)
	// StreamLegiScans resolves and streams all legi scans to the client,
	// providing the person associated with the scan
	StreamLegiScans(ctx context.Context, in *emptypb.Empty, opts ...grpc.CallOption) (Legiscanner_StreamLegiScansClient, error)
}

type legiscannerClient struct {
	cc grpc.ClientConnInterface
}

func NewLegiscannerClient(cc grpc.ClientConnInterface) LegiscannerClient {
	return &legiscannerClient{cc}
}

func (c *legiscannerClient) Beep(ctx context.Context, in *emptypb.Empty, opts ...grpc.CallOption) (*emptypb.Empty, error) {
	out := new(emptypb.Empty)
	err := c.cc.Invoke(ctx, "/vseth.vis.posperipherals.legiscanner.Legiscanner/Beep", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *legiscannerClient) Boop(ctx context.Context, in *emptypb.Empty, opts ...grpc.CallOption) (*emptypb.Empty, error) {
	out := new(emptypb.Empty)
	err := c.cc.Invoke(ctx, "/vseth.vis.posperipherals.legiscanner.Legiscanner/Boop", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *legiscannerClient) StreamLegiScans(ctx context.Context, in *emptypb.Empty, opts ...grpc.CallOption) (Legiscanner_StreamLegiScansClient, error) {
	stream, err := c.cc.NewStream(ctx, &Legiscanner_ServiceDesc.Streams[0], "/vseth.vis.posperipherals.legiscanner.Legiscanner/StreamLegiScans", opts...)
	if err != nil {
		return nil, err
	}
	x := &legiscannerStreamLegiScansClient{stream}
	if err := x.ClientStream.SendMsg(in); err != nil {
		return nil, err
	}
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	return x, nil
}

type Legiscanner_StreamLegiScansClient interface {
	Recv() (*StreamLegiScanResponse, error)
	grpc.ClientStream
}

type legiscannerStreamLegiScansClient struct {
	grpc.ClientStream
}

func (x *legiscannerStreamLegiScansClient) Recv() (*StreamLegiScanResponse, error) {
	m := new(StreamLegiScanResponse)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

// LegiscannerServer is the server API for Legiscanner service.
// All implementations must embed UnimplementedLegiscannerServer
// for forward compatibility
type LegiscannerServer interface {
	// Beep makes the legiscanner beep in a happy way
	Beep(context.Context, *emptypb.Empty) (*emptypb.Empty, error)
	// Boop makes the legiscanner boop in a sad way
	Boop(context.Context, *emptypb.Empty) (*emptypb.Empty, error)
	// StreamLegiScans resolves and streams all legi scans to the client,
	// providing the person associated with the scan
	StreamLegiScans(*emptypb.Empty, Legiscanner_StreamLegiScansServer) error
	mustEmbedUnimplementedLegiscannerServer()
}

// UnimplementedLegiscannerServer must be embedded to have forward compatible implementations.
type UnimplementedLegiscannerServer struct {
}

func (UnimplementedLegiscannerServer) Beep(context.Context, *emptypb.Empty) (*emptypb.Empty, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Beep not implemented")
}
func (UnimplementedLegiscannerServer) Boop(context.Context, *emptypb.Empty) (*emptypb.Empty, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Boop not implemented")
}
func (UnimplementedLegiscannerServer) StreamLegiScans(*emptypb.Empty, Legiscanner_StreamLegiScansServer) error {
	return status.Errorf(codes.Unimplemented, "method StreamLegiScans not implemented")
}
func (UnimplementedLegiscannerServer) mustEmbedUnimplementedLegiscannerServer() {}

// UnsafeLegiscannerServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to LegiscannerServer will
// result in compilation errors.
type UnsafeLegiscannerServer interface {
	mustEmbedUnimplementedLegiscannerServer()
}

func RegisterLegiscannerServer(s grpc.ServiceRegistrar, srv LegiscannerServer) {
	s.RegisterService(&Legiscanner_ServiceDesc, srv)
}

func _Legiscanner_Beep_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(emptypb.Empty)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(LegiscannerServer).Beep(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.vis.posperipherals.legiscanner.Legiscanner/Beep",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(LegiscannerServer).Beep(ctx, req.(*emptypb.Empty))
	}
	return interceptor(ctx, in, info, handler)
}

func _Legiscanner_Boop_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(emptypb.Empty)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(LegiscannerServer).Boop(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/vseth.vis.posperipherals.legiscanner.Legiscanner/Boop",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(LegiscannerServer).Boop(ctx, req.(*emptypb.Empty))
	}
	return interceptor(ctx, in, info, handler)
}

func _Legiscanner_StreamLegiScans_Handler(srv interface{}, stream grpc.ServerStream) error {
	m := new(emptypb.Empty)
	if err := stream.RecvMsg(m); err != nil {
		return err
	}
	return srv.(LegiscannerServer).StreamLegiScans(m, &legiscannerStreamLegiScansServer{stream})
}

type Legiscanner_StreamLegiScansServer interface {
	Send(*StreamLegiScanResponse) error
	grpc.ServerStream
}

type legiscannerStreamLegiScansServer struct {
	grpc.ServerStream
}

func (x *legiscannerStreamLegiScansServer) Send(m *StreamLegiScanResponse) error {
	return x.ServerStream.SendMsg(m)
}

// Legiscanner_ServiceDesc is the grpc.ServiceDesc for Legiscanner service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var Legiscanner_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "vseth.vis.posperipherals.legiscanner.Legiscanner",
	HandlerType: (*LegiscannerServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "Beep",
			Handler:    _Legiscanner_Beep_Handler,
		},
		{
			MethodName: "Boop",
			Handler:    _Legiscanner_Boop_Handler,
		},
	},
	Streams: []grpc.StreamDesc{
		{
			StreamName:    "StreamLegiScans",
			Handler:       _Legiscanner_StreamLegiScans_Handler,
			ServerStreams: true,
		},
	},
	Metadata: "vseth/vis/posperipherals/legiscanner/legiscanner.proto",
}
